Listing 5.1[em]Creating and Inserting Trace Data into a Trace Table from a Trace File
/********************************************************************
** NOTE - you will need to edit the path/filename on your system if 
**        you use this code to load your own trace files
*********************************************************************/

select EventClass, 
       EventSubClass, 
       TextData = convert(varchar(8000), TextData), 
       BinaryData, 
       ApplicationName, 
       Duration, 
       StartTime, 
       EndTime, 
       Reads, 
       Writes, 
       CPU, 
       ObjectID, 
       IndexID, 
       NestLevel
   into TraceTable
   FROM ::fn_trace_gettable('c:\temp\sampletrace_20060826_0232.trc', default)
   where TextData is not null
      or EventClass in (16, --  Attention
                        25, -- Lock:Deadlock
                        27, -- Lock:Timeout
                        33, -- Exception
                        58, -- Auto Update Stats
                        59, -- Lock:Deadlock Chain
                        79, -- Missing Column Statistics
                        80, -- Missing Join Predicate
                        92, -- Data File Auto Grow
                        93, -- Log File Auto Grow
                        94, -- Data File Auto Shrink
                        95) -- Log File Auto Shrink

Insert into TraceTable (EventClass, EventSubClass, 
            TextData, BinaryData, 
            ApplicationName, Duration, StartTime, EndTime, Reads, Writes, 
            CPU, ObjectID, IndexID, nestlevel)
     select EventClass, EventSubClass, 
            TextData = convert(varchar(7900), TextData), BinaryData, 
            ApplicationName, Duration, StartTime, EndTime, Reads, Writes, 
            CPU, ObjectID, IndexID, nestlevel
        FROM ::fn_trace_gettable('c:\temp\sampletrace_20060826_0108.trc', -1)
        where TextData is not null
           or EventClass in (16, --  Attention
                             25, -- Lock:Deadlock
                             27, -- Lock:Timeout
                             33, -- Exception
                             58, -- Auto Update Stats
                             59, -- Lock:Deadlock Chain
                             79, -- Missing Column Statistics
                             80, -- Missing Join Predicate
                             92, -- Data File Auto Grow
                             93, -- Log File Auto Grow
                             94, -- Data File Auto Shrink
                             95) -- Log File Auto Shrink
go
