use master
go
if object_id ('sp_stop_profiler_trace') is not null
    drop proc sp_stop_profiler_trace
go

create proc sp_stop_profiler_trace @TraceID int = null
as

if @TraceID is not null
begin
    -- Set the trace status to stop
    exec sp_trace_setstatus @TraceID, 0
    
    -- Delete the trace 
    exec sp_trace_setstatus @TraceID, 2
end
else
begin
--cg 2/8/06 - added a WHERE clause to eliminate a stop of the default trace
    declare c1 cursor for 
    SELECT distinct traceid FROM :: fn_trace_getinfo (DEFAULT) 
		WHERE traceId not in (select ID from sys.traces where is_default = 1)
    open c1
    fetch c1 into @TraceID
    while @@fetch_status = 0
    begin
        -- Set the trace status to stop
        exec sp_trace_setstatus @TraceID, 0
        
        -- Delete the trace 
        exec sp_trace_setstatus @TraceID, 2
        fetch c1 into @TraceID
    end
    close c1
    deallocate c1
end
