Listing 11.1[em]Full Backups with TLogs
--First need to change the recovery model from simple to full
--so that the tlogs are available for backup
ALTER DATABASE [AdventureWorks] SET RECOVERY FULL WITH NO_WAIT

--*** A Full database backup must be taken after the recovery mode has been changed
--*** in order set a base for future tlog backups.  If the full backups is not taken
--*** then tlog backups will fail.
--The Following full backup utilizes two devices on the same drive.  Often times multiple devices
--are backed up to different drives.  Backing up to different drives can speed up the overall backup
--time and help when you are running low on space on a drive where your backups are written.

BACKUP DATABASE [AdventureWorks] 
 TO  DISK = N'C:\mssql2005\backup\AdventureWorks_Full_Dev1.bak',  
     DISK = N'C:\mssql2005\backup\AdventureWorks_Full_Dev2.bak' 
 WITH NOFORMAT, NOINIT, SKIP, NOREWIND, NOUNLOAD,  STATS = 10

--Transaction log backups can be taken now that a base has been established
--The following tlog backup is written to a single file
BACKUP LOG [AdventureWorks] 
 TO  DISK = N'C:\mssql2005\backup\log\AdventureWorks_FirstAfterFull.trn' 
 WITH NOFORMAT, INIT,  NAME = N'AdventureWorks-Transaction Log  Backup', 
 SKIP, NOREWIND, NOUNLOAD,  STATS = 10, CHECKSUM
