USE AdventureWorks
GO
DECLARE 
    @subject nvarchar(255),
    @body varchar(max),
    @query nvarchar(max),
    @IllustrationId int,
    @query_attachment_filename nvarchar(255),
    @mailitem_id int

SELECT 
    @IllustrationId = pi.IllustrationId,
    @subject = 'SVG for "' + pm.Name + '" attached. '
FROM Production.Illustration pi
JOIN Production.ProductModelIllustration pmi
ON pmi.IllustrationId = pi.IllustrationId
JOIN Production.ProductModel pm
ON pm.ProductModelID = pmi.ProductModelID

SELECT 
    @body = 
        N'Attached, please find the SVG diagram for illustration #' + 
        CAST(@IllustrationId as nvarchar(10)) + 
        '. An SVG browser plug-in is required to view this file.'

SELECT @query = 
    N'SELECT Diagram FROM Production.Illustration
    WHERE IllustrationId = ' + CAST(@IllustrationId as nvarchar(10))

SELECT @query_attachment_filename = N'PM_' + 
    CAST(@IllustrationId as nvarchar(10)) + '.svg'

exec msdb.dbo.sp_send_dbmail 
    @subject=@subject, 
    @body=@body,
    @recipients='test@samspublishing.com', 
    @query=@query,
    @execute_query_database='AdventureWorks',
    @attach_query_result_as_file=1,
    @query_attachment_filename=@query_attachment_filename,
    @query_no_truncate=1,
    @exclude_query_output=1,
    @query_result_width=32767,
    @mailitem_id=@mailitem_id OUTPUT

SELECT sent_status, sent_date
FROM msdb.dbo.sysmail_allitems
WHERE mailitem_id = @mailitem_id
GO