if exists(select name from sysobjects where name = 'REPL_ROWS_GENERATOR')
  begin
    drop procedure REPL_ROWS_GENERATOR
  end
GO
CREATE PROCEDURE REPL_ROWS_GENERATOR
	@ROW_COUNT		INT = NULL  -- default this to 100 if nothing supplied
AS
SET NOCOUNT ON
DECLARE @INSERT_COUNT INT
SET @INSERT_COUNT = 1
IF @ROW_COUNT is NULL SET @ROW_COUNT = 100

WHILE (@INSERT_COUNT < @ROW_COUNT+1)
BEGIN
  BEGIN TRANSACTION
  INSERT INTO [AdventureWorks].[Sales].[Customer]
           ([TerritoryID]
           ,[CustomerType]
           ,[ModifiedDate])
     VALUES
           ( 1  -- TerritoryID 1 is NorthWest
           ,'I' -- Individuals
           ,getdate())

	PRINT 'INSERTING ROW: ' + convert (varchar(20),@INSERT_COUNT)
    
    COMMIT TRANSACTION

	SELECT @INSERT_COUNT = @INSERT_COUNT + 1
END
GO
-- EXEC REPL_ROWS_GENERATOR 
-- EXEC REPL_ROWS_GENERATOR 10
-- GO

