-- to see the port associated with database mirroring endpoint --
select name, type_desc, port, ip_address from sys.tcp_endpoints
select name,role_desc,state_desc from sys.database_mirroring_endpoints
sp_helpdb [AdventureWorks]
ALTER DATABASE AdventureWorks 
    SET PARTNER = 'TCP://DBARCHLT:1440' <<-- is the mirror's port/endpoint address
GO
ALTER DATABASE AdventureWorks 
  SET WITNESS = 'TCP://DBARCHLT:1450'   <<-- is the witness's port/endpoint address
GO
select @@servername

--*********************************--
--***  To CREATE a new endpoint ***-- PARTNER ROLE
--*********************************--
--CREATE ENDPOINT endpoint4mirroring
--STATE = STARTED
--AS TCP( LISTENER_PORT = 1430 )
--FOR DATABASE_MIRRORING (ROLE = PARTNER);

CREATE ENDPOINT [endpoint4mirroring] 
--	AUTHORIZATION [DBARCHLT\Paul Bertucci]
	STATE=STARTED
	AS TCP (LISTENER_PORT = 1430, LISTENER_IP = ALL)
	FOR DATA_MIRRORING (ROLE = PARTNER, AUTHENTICATION = WINDOWS NEGOTIATE
, ENCRYPTION = REQUIRED ALGORITHM RC4)

--*******************************************--
-- GRANTING Connection permissions for login --
--*******************************************--
GRANT CONNECT ON ENDPOINT::endpoint4mirroring TO [DBARCHLT\Paul Bertucci];
--*************************************--
--***  To DROP an existing endpoint ***--
--*************************************--
-- DROP ENDPOINT endpoint4mirroring;

--*************************************--
--*** To ALTER an existing endpoint ***--
--*************************************--
-- ALTER ENDPOINT endpoint4mirroring
-- STATE = STARTED
-- AS TCP( LISTENER_PORT = 1430 )
-- FOR DATABASE_MIRRORING (ROLE = PARTNER);

BACKUP DATABASE [AdventureWorks] 
    TO DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL.2\MSSQL\Backup\AdventureWorks4Mirror.bak' 
    WITH FORMAT
GO

BACKUP LOG [AdventureWorks] TO  
DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL.2\MSSQL\Backup\AdventureWorksLog.bak' 
GO
use [AdventureWorks]
go
EXEC REPL_ROWS_GENERATOR 10
go