ALTER TABLE dbo.authors
	DROP CONSTRAINT DF__authors__phone__04C4C0F4
GO
CREATE TABLE dbo.Tmp_authors
	(
	au_id dbo.id NOT NULL,
	au_lname varchar(40) NOT NULL,
	au_fname varchar(20) NOT NULL,
	phone char(12) NOT NULL,
	Gender char(1) NULL,
	address varchar(40) NULL,
	city varchar(20) NULL,
	state char(2) NULL,
	zip char(5) NULL,
	contract bit NOT NULL
	)  ON [PRIMARY]
GO
ALTER TABLE dbo.Tmp_authors ADD CONSTRAINT
	DF__authors__phone__04C4C0F4 DEFAULT ('UNKNOWN') FOR phone
GO
IF EXISTS(SELECT * FROM dbo.authors)
	 EXEC('INSERT INTO dbo.Tmp_authors (au_id, au_lname, au_fname, phone, address, city, state, zip, contract)
		SELECT au_id, au_lname, au_fname, phone, address, city, state, zip, contract FROM dbo.authors WITH (HOLDLOCK TABLOCKX)')
GO
ALTER TABLE dbo.titleauthor
	DROP CONSTRAINT FK__titleauth__au_id__14070484
GO
DROP TABLE dbo.authors
GO
EXECUTE sp_rename N'dbo.Tmp_authors', N'authors', 'OBJECT' 
GO
ALTER TABLE dbo.authors ADD CONSTRAINT
	UPKCL_auidind PRIMARY KEY CLUSTERED 
	(
	au_id
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
CREATE NONCLUSTERED INDEX aunmind ON dbo.authors
	(
	au_lname,
	au_fname
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF) ON [PRIMARY]
GO
ALTER TABLE dbo.authors WITH NOCHECK ADD CONSTRAINT
	CK__authors__au_id__03D09CBB CHECK (([au_id] like '[0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9][0-9][0-9]'))
GO
ALTER TABLE dbo.authors WITH NOCHECK ADD CONSTRAINT
	CK__authors__zip__05B8E52D CHECK (([zip] like '[0-9][0-9][0-9][0-9][0-9]'))
GO
