SELECT o.name AS table_name, au.type_desc AS allocation_type, au.data_pages, p.rows, partition_number
FROM sys.allocation_units AS au
    JOIN sys.partitions AS p ON au.container_id = p.partition_id
    JOIN sys.objects AS o ON p.object_id = o.object_id
    JOIN sys.indexes AS i ON p.index_id = i.index_id AND i.object_id = p.object_id
WHERE o.name = N'sales_big_Partitioned' 
ORDER BY o.name, p.index_id

/* Results from the previous SELECT statement
table_name	            allocation_type	data_pages	rows	partition_number
sales_big_Partitioned	IN_ROW_DATA	    1	        30	    1
sales_big_Partitioned	IN_ROW_DATA	    4824	    613560	2
sales_big_Partitioned	IN_ROW_DATA	    4846	    616450	3
sales_big_Partitioned	IN_ROW_DATA	    3596	    457210	4
*/