
CREATE TABLE [Sales].[Customer2](
	[CustomerID] [int] IDENTITY(1,1) NOT FOR REPLICATION NOT NULL,
	[TerritoryID] [int] NULL,
	[AccountNumber]  AS 
		(isnull('AW'+[dbo].[ufnLeadingZeros]([CustomerID]),'')),
	[CustomerType] [nchar](1) NOT NULL
		CONSTRAINT CK_Customer_CustomerType2 CHECK 
		 ((upper([CustomerType])='I' OR upper([CustomerType])='S')),
	[rowguid] [uniqueidentifier] ROWGUIDCOL  NOT NULL 
		CONSTRAINT [DF_Customer_rowguid2]  DEFAULT (newid()),
	[ModifiedDate] [datetime] NOT NULL 
		CONSTRAINT [DF_Customer_ModifiedDate2]  DEFAULT (getdate()),
 CONSTRAINT [PK_Customer_CustomerID2] PRIMARY KEY CLUSTERED 
	([CustomerID] ASC),
 CONSTRAINT FK_Customer_SalesTerritory_TerritoryID2 FOREIGN KEY
	([TerritoryID])
	REFERENCES [Sales].[SalesTerritory] ([TerritoryID])
) 
GO

