
USE adventureWorks

CREATE LOGIN OwnerLogin WITH PASSWORD = 'pw'
CREATE USER OwnerLogin FOR LOGIN OwnerLogin
EXEC sp_addrolemember N'db_owner', N'OwnerLogin'

CREATE LOGIN NonOwnerLogin WITH PASSWORD = 'pw'
CREATE USER NonOwnerLogin FOR LOGIN NonOwnerLogin

--Connect as the OwnerLogin at this point

CREATE VIEW OwnerView as
 select EmployeeID, Title, BirthDate, Gender, HireDate, SalariedFlag
  from HumanResources.Employee

GRANT SELECT ON [dbo].[OwnerView] TO [NonOwnerLogin]

--Connect as the NonOwnerLogin at this point

--The following select succeeds because the owner of the
--view that was granted permission is the same as the underlying
--table in the view

select * from OwnerView

--The following SELECT against the underlying table fails
--because the NonOwnerLogin does not have permission to
--select from the table.  He can only select through the view

select * from HumanResources.Employee

------------------------------------------------------------------------------------------
/*
--Connect as the OwnerLogin at this point

ALTER AUTHORIZATION ON OBJECT::dbo.OwnerView TO HumanResources

select * from sysobjects where name like 'ownerview'

sp_help ownerview
*/





