
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[Sales].[vw_OrderSummary]'))
DROP VIEW [Sales].[vw_OrderSummary]
go

CREATE VIEW Sales.vw_OrderSummary as
select datepart(yy, orderdate) as 'OrderYear', 
	datepart(mm, orderdate) as 'OrderMonth', 
	sum(TotalDue) as 'OrderTotal'
 from Sales.SalesOrderHeader
 group by datepart(yy, orderdate), datepart(mm, orderdate)
go

/*
select top 5 * from Sales.vw_OrderSummary

OrderYear   OrderMonth  OrderTotal
----------- ----------- ---------------------
2003        5           4449886.2315
2001        11          3690018.6652
2003        8           6775857.0745
2002        7           3781879.0708
2003        11          5961182.6761

select top 5 * 
 from Sales.vw_OrderSummary
 where OrderYear >= 2004
 order by OrderYear, OrderMonth

IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[Sales].[vw_OrderSummary]'))
DROP VIEW [Sales].[vw_OrderSummary]
GO

CREATE VIEW Sales.vw_OrderSummary
	WITH ENCRYPTION AS
select datepart(yy, orderdate) as 'OrderYear', 
	datepart(mm, orderdate) as 'OrderMonth', 
	sum(TotalDue) as 'OrderTotal'
 from Sales.SalesOrderHeader
 group by datepart(yy, orderdate), datepart(mm, orderdate)
go
*/
SELECT id, OBJECT_NAME(ID) 'ViewName', text 
FROM SYS.sysCOMMENTS
 WHERE OBJECT_NAME(ID) LIKE '%vw_OrderSummary%'


*/