--Listing 23.16 - Returning a Status Code from a Stored Procedure
IF EXISTS ( SELECT * FROM INFORMATION_SCHEMA.ROUTINES
               WHERE SPECIFIC_SCHEMA = N'dbo'
                 AND SPECIFIC_NAME = N'ytd_sales2')
   DROP PROCEDURE dbo.ytd_sales2
GO
--Create the procedure
CREATE PROC ytd_sales2 @title varchar(80)
AS
IF NOT EXISTS (SELECT * FROM titles WHERE title = @title)
    RETURN -101
SELECT ytd_sales
   FROM titles
   WHERE title = @title
RETURN
GO

-- Execute the procedure
DECLARE @status int
EXEC @status = ytd_sales2 'Life without Fear'
IF @status = -101
    PRINT 'No title with that name found.'
go

/*
ytd_sales
-----------
111
*/

-- Execute the procedure
DECLARE @status int
EXEC @status = ytd_sales2 'Life without Beer'
IF @status = -101
    PRINT 'No title with that name found.'
go

/*
No title with that name found.
*/

