-- Listing 23.21 - Using a Self-Join to Expand a Tree Relationship
WITH PartsTree (PartID, PartName, parentPartID, Level)
AS
(
-- Anchor member definition
    SELECT PartID, PartName, ParentPartID,
        0 AS Level
    FROM Parts AS parent
        where Parent.parentpartid is null
    UNION ALL
-- Recursive member definition
    SELECT child.PartID, child.PartName, child.ParentPArtID,
        Level + 1
    FROM Parts AS Child
    INNER JOIN PartsTree AS parent
        ON child.ParentPartID = parent.PArtID
)
-- Statement that executes the CTE
select * from PArtsTree
go

/*
PartID      PartName                       parentPartID Level
----------- ------------------------------ ------------ -----------
22          Car                            NULL         0
1           DriveTrain                     22           1
23          Body                           22           1
24          Frame                          22           1
2           Engine                         1            2
3           Transmission                   1            2
4           Axle                           1            2
12          Drive Shaft                    1            2
9           Flywheel                       3            3
10          Clutch                         3            3
16          Gear Box                       3            3
15          Reverse Gear                   16           4
17          First Gear                     16           4
18          Second Gear                    16           4
19          Third Gear                     16           4
20          Fourth Gear                    16           4
5           Radiator                       2            3
6           Intake Manifold                2            3
7           Exhaust Manifold               2            3
8           Carburetor                     2            3
13          Piston                         2            3
14          Crankshaft                     2            3
21          Piston Rings                   13           4
11          Float Valve                    8            4
*/
