--Listing 23.23 - Using Local and Global Temporary Tables in Stored Procedures
set nocount on
go
create proc temp_test2
as
select pub_id, pub_name, city, state
into ##temp
from publishers
where State in ('MA', 'DC', 'CA')

select pub_id, pub_name, city, state
into #temp
from publishers
where State in ('MA', 'DC', 'CA')
go

exec temp_test2
go

select * from ##temp
go

/*
pub_id pub_name                                 city                 state
------ ---------------------------------------- -------------------- -----
0736   New Moon Books                           Boston               MA
0877   Binnet & Hardley                         Washington           DC
1389   Algodata Infosystems                     Berkeley             CA
9912   Landlocked Books                         Boston               MA
9913   Blackberry's                             Cambridge            MA
*/

select * from #temp
go
/*
Server: Msg 208, Level 16, State 0, Line 1
Invalid object name '#temp'.
*/

--Note what happens if you try to run the stored procedure again:
exec temp_test2
go
/*
Server: Msg 2714, Level 16, State 6, Procedure temp_test2, Line 3
There is already an object named '##temp' in the database.
*/
