-- Listing 23.24 - Using Multiple Stored Procedures As an Alternative to Using WITH RECOMPILE
IF EXISTS ( SELECT * FROM INFORMATION_SCHEMA.ROUTINES
               WHERE SPECIFIC_SCHEMA = N'dbo'
                 AND SPECIFIC_NAME = N'advance_range')
   DROP PROCEDURE dbo.advance_range
GO
go

create proc get_titles_smallrange
   @low money, @high money
as
select * from titles
  where advance between @low and @high
return
go
create proc get_titles_bigrange
   @low money, @high money
as
select * from titles
  where advance between @low and @high
return
go
create proc advance_Range
   @low money, @high money
as
if @high - @low >= 1000
-- if the difference is over 5000
     exec get_titles_bigrange @low, @high
else
-- execute the small range procedure
     exec get_titles_smallrange @low, @high
go

