-- Listing 23.27 - Invoking Dynamic Queries in a Procedure by Using sp_executesql
IF EXISTS ( SELECT * FROM INFORMATION_SCHEMA.ROUTINES
               WHERE SPECIFIC_SCHEMA = N'dbo'
                 AND SPECIFIC_NAME = N'find_books_by_type2')
   DROP PROCEDURE dbo.find_books_by_type2
GOgo
create proc find_books_by_type2 @type1 char(12),
                                @type2 char(12) = null,
                                @type3 char(12) = null
as

exec sp_executesql N'select title_id, title = substring(title, 1, 40),
      type, price from bigpubs2005.dbo.titles where type = @type',
      N'@type char(12)',
      @type = @type1
if @type2 is not null
    exec sp_executesql N'select title_id, title = substring(title, 1, 40),
          type, price from bigpubs2005.dbo.titles where type = @type',
          N'@type char(12)',
          @type = @type2
if @type3 is not null
    exec sp_executesql N'select title_id, title = substring(title, 1, 40),
          type, price from bigpubs2005.dbo.titles where type = @type',
          N'@type char(12)',
          @type = @type3
go

set quoted_identifier off
exec find_books_by_type2 'business', 'mod_cook', 'trad_cook'
go

/*
title_id title                                    type         price
-------- ---------------------------------------- ------------ ----------------
BU1032   The Busy Executive's Database Guide      business     14.9532
BU1111   Cooking with Computers: Surreptitious Ba business     14.595
BU2075   You Can Combat Computer Stress!          business     15.894
BU7832   Straight Talk About Computers            business     14.9532

title_id title                                    type         price
-------- ---------------------------------------- ------------ -----------------
???author: please fix this too-long code line.-kitty
done - RRR
MC2222   Silicon Valley Gastronomic Treats        mod_cook     14.9532
MC3021   The Gourmet Microwave                    mod_cook     15.894

title_id title                                    type         price
-------- ---------------------------------------- ------------ ----------------
TC3218   Onions, Leeks, and Garlic: Cooking Secre trad_cook    0.0017
TC4203   Fifty Years in Buckingham Palace Kitchen trad_cook    14.595
TC7777   Sushi, Anyone?                           trad_cook    14.3279
*/