-- Listing 23.29 - Lack of Column List in INSERT Statement Causing Procedure to Fail
use bigpubs2005
go
IF EXISTS ( SELECT * FROM INFORMATION_SCHEMA.ROUTINES
               WHERE SPECIFIC_SCHEMA = N'dbo'
                 AND SPECIFIC_NAME = N'insert_publishers')
   DROP PROCEDURE dbo.insert_publishers
GO
create proc insert_publishers @pub_id char(4),
                              @pub_name varchar(40),
                              @city varchar(20),
                              @state char(2),
                              @country varchar(30)
as
INSERT INTO bigpubs2005.dbo.publishers
VALUES(@pub_id, @pub_name, @city, @state, @country)
if @@error = 0
    print 'New Publisher added'
go

exec insert_publishers '9950', 'Sams Publishing', 'Indianapolis', 'IN', 'USA'
go

/*
New Publisher added
*/


alter table publishers add street varchar(80) null
go

exec insert_publishers '9951', 'Pearson Education', 'Indianapolis', 'IN', 'USA'
go

/*
Msg 213, Level 16, State 1, Procedure insert_publishers, Line 7
Insert Error: Column name or number of supplied values does not match table
 definition.
*/