--Listing 23.31 - Template Code for a Calling Batch or Stored Procedure That Might Execute a Stored Procedure Built with the Template in Listing 23.30
/* Retrieve status code to determine if proc was successful */

declare @status_val int, @trncnt int

select @trncnt = @@trancount  -- save @@trancount value

if @trncnt = 0   -- transaction has not begun
  begin tran t1  -- begin tran increments nest level to 1
else             -- otherwise, already in a transaction
  save tran t1   -- save tran doesn't increment nest level

/* do some processing if required */

if (@@error != 0) -- or other error condition
begin
    rollback tran t1  -- rollback to savepoint,or begin tran
    return            -- and exit batch/procedure
end

execute @status_val = ptran1 --exec procedure, begin nesting

if @status_val = 25 -- if proc performed rollback
begin        -- determine whether to rollback or continue
    rollback tran t1
    return
end

/* more processing if required */

if @trncnt = 0    -- this proc/batch issued begin tran
  commit tran t1  -- commit tran, decrement @@trancount to 0
return            -- commit not required with save tran
go
