--Listing 23.33 - Using a TRY...CATCH Construct for Error Handling in a Stored Procedure
use bigpubs2005
go
alter proc insert_publishers @pub_id char(4),
                              @pub_name varchar(40),
                              @city varchar(20),
                              @state char(2),
                              @country varchar(30)
as
BEGIN TRY
    INSERT INTO bigpubs2005.dbo.publishers
             (pub_id, pub_name, city, state, country)
       VALUES(@pub_id, @pub_name, @city, @state, @country)
    -- if no error occurs, we should see this print statement
    print 'New Publisher added'
END TRY
BEGIN CATCH
    -- invoke the error_handler procedure
    exec error_handler
    -- return a non-zero status code
    RETURN -101
END CATCH
-- if successful execution, return 0
RETURN 0
go

exec insert_publishers '9951', 'Pearson Education', 'Indianapolis', 'IN', 'USA'
exec insert_publishers '9950', 'Sams Publishing', 'Indianapolis', 'IN', 'USA'
go


/*
New Publisher added

Msg 50000, Level 16, State 1, Procedure insert_publishers, Line 18
Failed to add new publisher for the following reason:
Error: 2627, Severity: 14, State: 1, in proc insert_publishers at line 8,
 Message: "Violation of PRIMARY KEY constraint 'UPKCL_pubind'. Cannot insert
 duplicate key in object 'dbo.publishers'."
*/
