CREATE TRIGGER tr_ddl_IndexAudit 
ON DATABASE 
FOR CREATE_INDEX, ALTER_INDEX, DROP_INDEX
AS 
          DECLARE @EventData XML 
          -- Capture event data from the EVENTDATA function
          SET @EventData = EVENTDATA() 
          -- Select the auditing info from the XML stream 
          SELECT   @EventData.query ('data(/EVENT_INSTANCE/PostTime)') AS [Event Time], 
                   @EventData.query ('data(/EVENT_INSTANCE/EventType)') AS [Event Type], 
                   @EventData.query ('data(/EVENT_INSTANCE/ServerName)') AS [Server Name], 
                   @EventData.query ('data(/EVENT_INSTANCE/TSQLCommand/CommandText)') AS [Command Text] 
GO

CREATE NONCLUSTERED INDEX [nc_titles_type] ON [dbo].[titles] ( [type] ASC )

