-- SEE SQL SERVER DB Option --
SELECT name, 
       database_id, 
       source_database_id, -- source DB of the snapshot
       create_date, 
       snapshot_isolation_state_desc 
FROM sys.databases
WHERE name like '%AdventureWorks%'
------------------------------
-- 6:00AM DATABASE SNAPSHOT --
------------------------------
IF EXISTS 
   (SELECT database_id FROM sys.databases WHERE NAME='SNAP_AdventureWorks_6AM') 
   DROP DATABASE SNAP_AdventureWorks_6AM
go
CREATE DATABASE SNAP_AdventureWorks_6AM 
ON 
 ( NAME = AdventureWorks_Data, 
   FILENAME= 'C:\Program Files\Microsoft SQL Server\MSSQL.2\MSSQL\DATA\SNAP_AdventureWorks_data_6AM.snap'
 )
AS SNAPSHOT OF AdventureWorks
go
-- SELECT * FROM [SNAP_AdventureWorks_6AM].[Sales].[Customer]
SELECT [CreditCardID]
      ,[CardType]
      ,[CardNumber]
      ,[ExpMonth]
      ,[ExpYear]
      ,[ModifiedDate]
  FROM [SNAP_AdventureWorks_6AM].[Sales].[CreditCard]
WHERE CreditCardID = 1
go
SELECT [CreditCardID]
      ,[CardType]
      ,[CardNumber]
      ,[ExpMonth]
      ,[ExpYear]
      ,[ModifiedDate]
  FROM [AdventureWorks].[Sales].[CreditCard]
WHERE CreditCardID = 1
go
--
Update [AdventureWorks].[Sales].[CreditCard]
   SET [ExpMonth] = 1,
       [ExpYear] = 2010
WHERE CreditCardID = 1

-------------------------------
-- 12:00PM DATABASE SNAPSHOT --
-------------------------------
IF EXISTS 
   (SELECT database_id FROM sys.databases WHERE NAME='SNAP_AdventureWorks_12PM') 
   DROP DATABASE SNAP_AdventureWorks_12PM
go
CREATE DATABASE SNAP_AdventureWorks_12PM 
ON 
 ( NAME = AdventureWorks_Data, 
  FILENAME= 'C:\Program Files\Microsoft SQL Server\MSSQL.2\MSSQL\DATA\SNAP_AdventureWorks_data_12PM.snap'
 )
AS SNAPSHOT OF AdventureWorks
go
------------------------------
-- 6:00PM DATABASE SNAPSHOT --
------------------------------
IF EXISTS 
   (SELECT database_id FROM sys.databases WHERE NAME='SNAP_AdventureWorks_6PM') 
   DROP DATABASE SNAP_AdventureWorks_6PM
go
CREATE DATABASE SNAP_AdventureWorks_6PM 
ON 
 ( NAME = AdventureWorks_Data, 
  FILENAME= 'C:\Program Files\Microsoft SQL Server\MSSQL.2\MSSQL\DATA\SNAP_AdventureWorks_data_6PM.snap'
 )
AS SNAPSHOT OF AdventureWorks
go
-------------------------------
-- 12:00AM DATABASE SNAPSHOT --
-------------------------------
IF EXISTS 
   (SELECT database_id FROM sys.databases WHERE NAME='SNAP_AdventureWorks_12AM') 
   DROP DATABASE SNAP_AdventureWorks_12AM
go
CREATE DATABASE SNAP_AdventureWorks_12AM 
ON 
 ( NAME = AdventureWorks_Data, 
  FILENAME= 'C:\Program Files\Microsoft SQL Server\MSSQL.2\MSSQL\DATA\SNAP_AdventureWorks_data_12AM.snap'
 )
AS SNAPSHOT OF AdventureWorks
go
------------------------------------
-- Catalog View: sys.master_files --
------------------------------------
SELECT * FROM sys.master_files
SELECT database_id, file_id, name, physical_name FROM sys.master_files
WHERE Name = 'AdventureWorks_data'
and is_sparse = 1
go
---------------------------------------------------------------------------------
-- number of bytes each sparse file of the snapshot is currently using on disk --
---------------------------------------------------------------------------------
if exists(select name from sysobjects where name = 'SNAP_SIZE_UNLEASHED')
  begin
    drop procedure SNAP_SIZE_UNLEASHED
  end
GO
CREATE PROCEDURE SNAP_SIZE_UNLEASHED 
       @DBDATA varchar(255) = NULL
AS
if @DBDATA is not null
   BEGIN
      SELECT B.name as 'Sparse files for Database Name',A.DbId, A.FileId, BytesOnDisk 
      FROM fn_virtualfilestats (NULL, NULL) A,
           sys.master_files B
      WHERE A.DbID = B.database_id
        and A.FileID = B.file_id
        and B.is_sparse = 1
        and B.name = @DBDATA
   END
ELSE
   BEGIN
      SELECT B.name as 'Sparse files for Database Name',A.DbId, A.FileId, BytesOnDisk 
      FROM fn_virtualfilestats (NULL, NULL) A,
           sys.master_files B
      WHERE A.DbID = B.database_id
        and A.FileID = B.file_id
        and B.is_sparse = 1
   END
go
-- EXEC SNAP_SIZE_UNLEASHED 'AdventureWorks_Data'
-- EXEC SNAP_SIZE_UNLEASHED
-----------------------------------------------------------------------
-- Reverting AdventureWorks DB to 'SNAP_AdventureWorks_6PM' Snapshot -- 
-----------------------------------------------------------------------
USE master
go
RESTORE DATABASE AdventureWorks FROM DATABASE_SNAPSHOT = 'SNAP_AdventureWorks_6PM'
go
----------------------------------------
-- 6:00AM DATABASE SNAPSHOT ON MIRROR --
----------------------------------------
IF EXISTS 
   (SELECT database_id FROM sys.databases WHERE NAME='SNAP_AdventureWorks_6AM') 
   DROP DATABASE SNAP_AdventureWorks_6AM
go
CREATE DATABASE SNAP_AdventureWorks_6AM 
ON 
 ( NAME = AdventureWorks_Data, 
   FILENAME= 'C:\Program Files\Microsoft SQL Server\MSSQL.4\MSSQL\DATA\SNAP_AdventureWorks_data_6AM.snap'
 )
AS SNAPSHOT OF AdventureWorks
go
-- SELECT * FROM [SNAP_AdventureWorks_6AM].[Sales].[Customer]
SELECT [CreditCardID]
      ,[CardType]
      ,[CardNumber]
      ,[ExpMonth]
      ,[ExpYear]
      ,[ModifiedDate]
  FROM [SNAP_AdventureWorks_6AM].[Sales].[CreditCard]
WHERE CreditCardID = 1
go
----------------------------------------------------
-- See the file allocations for a source database --
----------------------------------------------------
sp_helpdb AdventureWorks
go
sp_helpdb unleashed
go
---------------------------------
-- REPORTING DATABASE SNAPSHOT --
---------------------------------
IF EXISTS 
   (SELECT database_id FROM sys.databases WHERE NAME='SNAP_AdventureWorks_REPORTING') 
   DROP DATABASE SNAP_AdventureWorks_REPORTING
go
CREATE DATABASE SNAP_AdventureWorks_REPORTING 
ON 
 ( NAME = AdventureWorks_Data, 
   FILENAME= 'C:\Program Files\Microsoft SQL Server\MSSQL.4\MSSQL\DATA\SNAP_AdventureWorks_data_REPORTING.snap'
 )
AS SNAPSHOT OF AdventureWorks
go