--LISTING 30.3 Returning Query Plan Stats for the 10 Most Recently Executed Procedures

select TOP 10 usecounts, size_in_bytes,
max(last_execution_time) as last_execution_time,
sum(total_logical_reads) as total_logical_reads,
sum(total_physical_reads) as total_physical_reads,
sum(total_worker_time/1000) as total_CPU_time,
sum(total_elapsed_time/1000) as total_elapsed_time,
replace(substring (text,
patindex('%create procedure%', text),
datalength(text)),
'create procedure', '') as procname
from sys.dm_exec_query_stats s
join sys.dm_exec_cached_plans p on s.plan_handle = p.plan_handle
CROSS APPLY sys.dm_exec_sql_text(p.plan_handle) as st
where p.objtype = 'Proc' and p.cacheobjtype = 'Compiled Plan'
group by usecounts, size_in_bytes, text
order by max(last_execution_time) desc