use bigpubs2005
go
--The first statement is used to disable any previously created
--DDL triggers in the database which would prevent creating a new table.
DISABLE TRIGGER ALL ON DATABASE
go
create table data_table
    (id int identity,
     data_field_1 varchar(10),
     timestamp timestamp)
go
insert data_table (data_field_1) values ('foo')
go

--Next, you need to ensure that bigpubs2005 is configured to allow snapshot isolation:
ALTER DATABASE bigpubs2005 SET ALLOW_SNAPSHOT_ISOLATION ON

--In one user session, execute the following SQL statements:
SET TRANSACTION ISOLATION LEVEL SNAPSHOT
go
begin tran
select * from data_table
go

/*
id          data_field_1 timestamp
----------- ------------ ------------------
1           foo          0x0000000000000BC4
*/

--in another user session, execute the following UPDATE statement:
update data_table set data_field_1 = 'bar'
   where id = 1
go

--go back to the original session and attempt the following update:
update data_table set data_field_1 = 'fubar'
   where id = 1
go

/*
Msg 3960, Level 16, State 4, Line 1
Snapshot isolation transaction aborted due to update conflict. You cannot use
 snapshot isolation to access table 'dbo.data_table' directly or indirectly in
 database 'bigpubs2005' to update, delete, or insert the row that has been
 modified or deleted by another transaction. Retry the transaction or change the
 isolation level for the update/delete statement.
*/
