-- Network Connection Info --
SELECT session_id, protocol_type, num_reads, num_writes, net_packet_size
 from sys.dm_exec_connections
SELECT * from sys.dm_exec_connections
SELECT * from sys.dm_exec_requests
SELECT session_id, command, database_id, user_id, cpu_time, reads, writes, logical_reads
from sys.dm_exec_requests
order by cpu_time desc

-- SELECT * from sys.dm_exec_sessions
-- CPU related --
SELECT * from sys.dm_os_sys_info
-----------------------------------------------------------
-- entire SQL Server Instance breakdown - PerfMon values --
-----------------------------------------------------------
SELECT * from sys.sysperfinfo
--------------------------------------
-- Current processes for SQL Server --
--------------------------------------
SELECT * from sys.sysprocesses

SELECT * from sys.sysservers

SELECT * from sys.configurations

SELECT spid, lastwaittype, dbid, uid, cpu, physical_io, memusage,status, loginame, program_name
from sys.sysprocesses
ORDER BY cpu desc

SELECT scheduler_id, current_tasks_count, runnable_tasks_count
FROM Sys.dm_os_schedulers
WHERE scheduler_id < 255

SELECT top 50 sum(total_worker_time) as Total_CPU,
              sum(execution_count) as Total_Count,
              count(*) as Total_Statements,
              plan_handle
FROM   sys.dm_exec_query_stats
GROUP BY plan_handle
Order by 1 desc
GO
SELECT total_worker_time, b.text
FROM sys.dm_exec_query_stats A
CROSS APPLY sys.dm_exec_sql_text (A.plan_handle) AS B
order by 1 desc
GO
SELECT type, sum(multi_pages_kb) 
FROM Sys.dm_os_memory_clerks
WHERE multi_pages_kb <> 0
Group by type

SELECT substring(name,1,25) AS Name,single_pages_kb,single_pages_in_use_kb 
FROM sys.dm_os_memory_cache_counters

SELECT substring(type,1,25) as Type,sum(pages_allocated_count) as Total_Memory_Allocated
FROM sys.dm_os_memory_objects
group by type
order by 2 desc


SELECT sum(awe_allocated_kb) / 1024
FROM sys.dm_os_memory_clerks

DBCC MEMORYSTATUS

SELECT substring(wait_type,1,15) AS Latch_Waits, waiting_tasks_count, wait_time_ms
FROM sys.dm_os_wait_stats
WHERE wait_type like 'PAGEIOLATCH%'
ORDER BY wait_type

SELECT * from sys.dm_io_cluster_shared_drives

SELECT database_id, file_id, num_of_reads, num_of_bytes_read, num_of_bytes_written, size_on_disk_bytes
FROM sys.dm_io_virtual_file_stats (1,1)


DBCC SHOWCONTIG
Go
DBCC PERFMON
Go
DBCC SQLPERF(THREADS)
go

DBCC SQLPERF( LOGSPACE )
select * from sys.dm_exec_connections
select * from sys.dm_exec_sessions

DECLARE @value INT
SELECT @value = AVG( DATEDIFF( mi, login_time, GETDATE()))
FROM sys.dm_exec_sessions
WHERE session_id > 26

SELECT * From sys.dm_exec_sessions

DBCC PROCCACHE 
DBCC FREEPROCCACHE 

SELECT Top 100 A.total_worker_time, b.text
FROM sys.dm_exec_query_stats A
CROSS APPLY sys.dm_exec_sql_text (A.plan_handle) AS B
order by 1 desc
GO
SELECT TOP 100 RowNumber, 
               TextData, 
               LoginName, 
               spid,
               Reads, 
               Writes, 
               CPU, 
               Duration
FROM Top100TraceTable  -- must update this table name with your table
WHERE Reads is not null
ORDER BY Reads DESC
GO
DBCC MEMORYSTATUS
DBCC SHOWCONTIG 
DBCC FREESESSIONCACHE
DBCC FREESYSTEMCACHE
DBCC FREEPROCCACHE
DBCC SQLPERF ([sys.dm_os_wait_stats],clear) 
sp_monitor
DBCC perfmon
SELECT  @@connections as 'Connections',
        @@pack_received as 'Packets Received',
        @@pack_sent as 'Packets Sent',
        getdate() as 'As of datetime'
go
sp_configure 'show advanced options', 1
sp_configure 'affinity I/O mask'


