--Listing 35.10 - A Recursive CTE to Return All Subparts Two Levels Below a Part
WITH PartsCTE(partid, partname, parentpartid, lvl)
AS
(
  SELECT partid, partname, parentpartid, 0
  FROM PARTS
  WHERE partid = 1 -- Drivetrain
  UNION ALL

  SELECT P.partid, P.partname, P.parentpartid, PP.lvl+1
  FROM Parts as P
    JOIN PartsCTE as PP
      ON P.parentpartid = PP.Partid
    where lvl < 2
)
SELECT PartID, Partname, ParentPartid, lvl
FROM PartsCTE
where lvl = 2
go

/*
PartID      Partname                       ParentPartid lvl
----------- ------------------------------ ------------ -----------
9           Flywheel                       3            2
10          Clutch                         3            2
16          Gear Box                       3            2
5           Radiator                       2            2
6           Intake Manifold                2            2
7           Exhaust Manifold               2            2
8           Carburetor                     2            2
13          Piston                         2            2
14          Crankshaft                     2            2
*/
