--Listing 35.11 - Using Local Variables in a Recursive CTE
DECLARE @partid AS INT, @lvl AS INT;
SET @partid = 22; -- Car
SET @lvl = 2; -- two levels
WITH PartsCTE(partid, partname, parentpartid, lvl)
AS
(
  SELECT partid, partname, parentpartid, 0
  FROM PARTS
  WHERE partid = @partid
  UNION ALL

  SELECT P.partid, P.partname, P.parentpartid, PP.lvl+1
  FROM Parts as P
    JOIN PartsCTE as PP
      ON P.parentpartid = PP.Partid
  WHERE lvl < @lvl
)
SELECT PartID, Partname, ParentPartid, lvl
FROM PartsCTE

/*
PartID      Partname                       ParentPartid lvl
----------- ------------------------------ ------------ -----------
22          Car                            NULL         0
1           DriveTrain                     22           1
23          Body                           22           1
24          Frame                          22           1
2           Engine                         1            2
3           Transmission                   1            2
4           Axle                           1            2
12          Drive Shaft                    1            2
*/
