--Listing 35.13 - Generating a Formatted Report with a Recursive CTE
WITH PartsCTE(partid, partname, parentpartid, lvl, sortcol)
AS
(
  SELECT partid, partname, parentpartid, 0, cast(partid as varbinary(max))
  FROM Parts
  WHERE partid = 22
  UNION ALL
  SELECT P.partid, P.partname, P.parentpartid, PP.lvl+1,
         CAST(sortcol + CAST(P.partid AS BINARY(4)) AS VARBINARY(max))
  FROM Parts AS P
    JOIN PartsCTE AS PP
      ON P.parentpartID = PP.PartID
)
SELECT
  REPLICATE('--', lvl)
    + right('>',lvl)
    + partname AS partname
FROM PArtsCTE
order by sortcol
go

/*
partname
-----------------------------------
Car
-->DriveTrain
---->Engine
------>Radiator
------>Intake Manifold
------>Exhaust Manifold
------>Carburetor
-------->Float Valve
------>Piston
-------->Piston Rings
------>Crankshaft
---->Transmission
------>Flywheel
------>Clutch
------>Gear Box
-------->Reverse Gear
-------->First Gear
-------->Second Gear
-------->Third Gear
-------->Fourth Gear
---->Axle
---->Drive Shaft
-->Body
-->Frame
*/
