--Listing 35.17 - Using PARTITION BY to Rank Rows Within Groups
select top 20 WITH TIES p.pub_id, pub_name, type, count(*) as num_titles,
ROW_NUMBER () OVER (partition by type order by count(*) DESC, p.pub_id) as Rank
from publishers p join titles t on p.pub_id = t.pub_id
group by p.pub_id, p.pub_name, type
order by type, count(*) desc
go

/*
pub_id pub_name                                 type         num_titles  Rank
------ ---------------------------------------- ------------ ----------- --------
9906   Tomato Books                             biography    4           1
9911   Jones Jones and Johnson                  biography    4           2
9905   Gooseberry Titles                        biography    2           3
9900   Boysenberry Books                        biography    1           4
9903   Kumquat Technical Publishing             biography    1           5
9904   Strawberry Publications                  biography    1           6
9909   North American Press                     biography    1           7
9913   Blackberry's                             biography    1           8
9914   Normanskill Printing Company             biography    1           9
9916   Nordome Titles                           biography    1           10
9918   Significant Titles Company               biography    1           11
1389   Algodata Infosystems                     business     3           1
0736   New Moon Books                           business     1           2
9911   Jones Jones and Johnson                  children     21          1
9914   Normanskill Printing Company             children     13          2
9905   Gooseberry Titles                        children     12          3
9901   GGG&G                                    children     11          4
9903   Kumquat Technical Publishing             children     11          5
9915   Beanplant General                        children     9           6
9900   Boysenberry Books                        children     8           7
9913   Blackberry's                             children     8           8
*/
