--Listing 35.19 - Using the NTILE Function
select p.pub_id, pub_name, count(*) as num_titles,
NTILE(3) OVER (order by count(*) DESC) as NTILE,
ROW_NUMBER() OVER (order by count(*) DESC) as RowNum
from publishers p join titles t on p.pub_id = t.pub_id
group by p.pub_id, p.pub_name
order by count(*) desc
go

/*
pub_id pub_name                                 num_titles  NTILE RowNum
------ ---------------------------------------- ----------- ----- ------
9911   Jones Jones and Johnson                  44          1     1
9904   Strawberry Publications                  34          1     2
9907   Incandescent Imprints                    33          1     3
9905   Gooseberry Titles                        32          1     4
9909   North American Press                     30          1     5
9912   Landlocked Books                         30          2     6
9913   Blackberry's                             28          2     7
9914   Normanskill Printing Company             28          2     8
9910   Sidney's Books and More                  28          2     9
9906   Tomato Books                             28          2     10
9903   Kumquat Technical Publishing             28          3     11
9902   Lemon Legal Publishing                   27          3     12
9901   GGG&G                                    25          3     13
9908   Springfield Publishing                   25          3     14
9900   Boysenberry Books                        23          4     15
9916   Nordome Titles                           22          4     16
9915   Beanplant General                        21          4     17
9917   BFG Books                                17          4     18
9918   Significant Titles Company               17          5     19
0877   Binnet & Hardley                         6           5     20
1389   Algodata Infosystems                     6           5     21
0736   New Moon Books                           5           5     22
*/
