--Listing 35.20 - Using a CASE Expression to Provide Meaningful Labels to Ranking Values
select p.pub_id, pub_name, count(*) as num_titles,
    case NTILE(5) OVER (order by count(*) DESC)
        when 1 then 'Highest'
        when 2 then 'Above Average'
        when 3 then 'Average'
        when 4 then 'Below Average'
        when 5 then 'Lowest'
        end as Ranking
from publishers p join titles t on p.pub_id = t.pub_id
group by p.pub_id, p.pub_name
order by pub_id
go

/*
pub_id pub_name                                 num_titles  Ranking
------ ---------------------------------------- ----------- -------------
0736   New Moon Books                           5           Lowest
0877   Binnet & Hardley                         6           Lowest
1389   Algodata Infosystems                     6           Lowest
9900   Boysenberry Books                        23          Below Average
9901   GGG&G                                    25          Average
9902   Lemon Legal Publishing                   27          Average
9903   Kumquat Technical Publishing             28          Average
9904   Strawberry Publications                  34          Highest
9905   Gooseberry Titles                        32          Highest
9906   Tomato Books                             28          Above Average
9907   Incandescent Imprints                    33          Highest
9908   Springfield Publishing                   25          Average
9909   North American Press                     30          Highest
9910   Sidney's Books and More                  28          Above Average
9911   Jones Jones and Johnson                  44          Highest
9912   Landlocked Books                         30          Above Average
9913   Blackberry's                             28          Above Average
9914   Normanskill Printing Company             28          Above Average
9915   Beanplant General                        21          Below Average
9916   Nordome Titles                           22          Below Average
9917   BFG Books                                17          Below Average
9918   Significant Titles Company               17          Lowest
*/
