--Listing 35.21 - Using ROW_NUMBER to Page Through Results
with pub_titles as
(
select p.pub_id, pub_name, count(*) as num_titles,
ROW_NUMBER () OVER (order by count(*) DESC, p.pub_id) as Rank
from publishers p join titles t on p.pub_id = t.pub_id
group by p.pub_id, p.pub_name
)
select * from pub_titles
where Rank between 6 and 10
go

/*
pub_id pub_name                                 num_titles  Rank
------ ---------------------------------------- ----------- --------------------
9912   Landlocked Books                         30          6
9903   Kumquat Technical Publishing             28          7
9906   Tomato Books                             28          8
9910   Sidney's Books and More                  28          9
9913   Blackberry's                             28          10
*/
