--Listing 35.22 - Using Local Variables for Determining Page Size When Paging Through Results
declare @pagesize tinyint,
        @pagenum tinyint;
set @pagesize = 6;
set @pagenum = 2;

with pub_titles as
(
select p.pub_id, pub_name, count(*) as num_titles,
ROW_NUMBER () OVER (order by count(*) DESC, p.pub_id) as Rank
from publishers p join titles t on p.pub_id = t.pub_id
group by p.pub_id, p.pub_name
)
select * from pub_titles
where Rank between ((@pagenum - 1) * @pagesize) + 1
               and @pagenum * @pagesize
go

/*
pub_id pub_name                                 num_titles  Rank
------ ---------------------------------------- ----------- --------------------
9903   Kumquat Technical Publishing             28          7
9906   Tomato Books                             28          8
9910   Sidney's Books and More                  28          9
9913   Blackberry's                             28          10
9914   Normanskill Printing Company             28          11
9902   Lemon Legal Publishing                   27          12
*/
