--Listing 35.23 - Using a Temp Table for Paging Through Results
select p.pub_id, pub_name, count(*) as num_titles,
       ROW_NUMBER () OVER (order by count(*) DESC, p.pub_id) as Rank
   into #paging_table
   from publishers p join titles t on p.pub_id = t.pub_id
   group by p.pub_id, p.pub_name
go
create unique clustered index idx1 on #paging_table(Rank)
go
declare @pagesize tinyint,
        @pagenum tinyint;
set @pagesize = 6;
set @pagenum = 2;
SELECT *
FROM #paging_table
WHERE Rank BETWEEN (@pagenum-1)*@pagesize+1 AND @pagenum*@pagesize
ORDER BY Rank
set @pagesize = 6;
set @pagenum = 4;
SELECT *
FROM #paging_table
WHERE Rank BETWEEN (@pagenum-1)*@pagesize+1 AND @pagenum*@pagesize
ORDER BY Rank
go

/*
pub_id pub_name                                 num_titles  Rank
------ ---------------------------------------- ----------- --------------------
9903   Kumquat Technical Publishing             28          7
9906   Tomato Books                             28          8
9910   Sidney's Books and More                  28          9
9913   Blackberry's                             28          10
9914   Normanskill Printing Company             28          11
9902   Lemon Legal Publishing                   27          12

pub_id pub_name                                 num_titles  Rank
------ ---------------------------------------- ----------- --------------------
9918   Significant Titles Company               17          19
0877   Binnet & Hardley                         6           20
1389   Algodata Infosystems                     6           21
0736   New Moon Books                           5           22
*/
