--Listing 35.24 - Using NTILE to Generate Page Numbers
select TOP 500 t.title_id,
       left(title, 20) as title,
       sum(qty) as total_sales,
       NTILE(50) OVER(ORDER BY sum(qty) desc) AS pagenum
   into #title_list
   from titles t join sales s on t.title_id = s.title_id
   group by t.title_id, title
go
create clustered index page_index on #title_list(pagenum)
go
select * from #title_list
where pagenum = 11
go

/*
title_id title                total_sales pagenum
-------- -------------------- ----------- --------------------
FI1704   Journey              295872      11
FI2784   Rhoda: A Life in Sto 295836      11
FI4524   The Unconsoled       295584      11
FI4554   The Spy Who Came in  295500      11
FI0897   Polar Star           295308      11
CH0126   Little Bear          295296      11
FI5040   The Tombs of Atuan   295284      11
PS1372   Computer Phobic AND  295172      11
FI7820   Tinker, Tailor, Sold 295092      11
FI2816   Zuckerman Unbound    294960      11
CH0623   The Black Cauldron   294960      11
*/
