--Listing 35.26 - Using PIVOT to Return Total Sales by Year
with title_sales as
(select t.title_id,
       datepart(year, ord_date) as year,
       qty as total_sales
from sales s join titles t on s.title_id = t.title_id
where t.type = 'business')
select ts_pivot.title_id,
       isnull([1993], 0) as [1993],
       isnull([1994], 0) as [1994],
       isnull([1995], 0) as [1995]
from title_sales
pivot (sum(total_sales) for year in ([1993], [1994], [1995])
) as ts_pivot
go

/*
title_id 1993        1994        1995
-------- ----------- ----------- -----------
BU1032   95556       97131       59772
BU1111   104149      88116       72336
BU2075   108995      117888      84588
BU7832   102975      104616      78240
*/

--create a temporary table from the results of the PIVOT query in Listing 35.26
with title_sales as
(select t.title_id,
       datepart(year, ord_date) as year,
       qty
from sales s join titles t on s.title_id = t.title_id
where t.type = 'business')
select ts_pivot.title_id,
       isnull([1993], 0) as [1993],
       isnull([1994], 0) as [1994],
       isnull([1995], 0) as [1995]
into #title_sales_by_year
from title_sales
pivot (sum(qty) for year in ([1993], [1994], [1995])
) as ts_pivot
go
select title_id, [1993], [1994], [1995]
    from #title_sales_by_year
go

/*
title_id 1993        1994        1995
-------- ----------- ----------- -----------
BU1032   95556       97131       59772
BU1111   104149      88116       72336
BU2075   108995      117888      84588
BU7832   102975      104616      78240
*/
