--Listing 35.29 - Using CROSS APPLY
select st.stor_id, stor_name, s.ord_date, s.qty
from stores st
cross apply
dbo.fn_GetTopOrders (st.stor_id, 3) as s
where st.state = 'MI'
and st.stor_name in ('Barnes & Noble', 'B Dalton BookSeller', 'Waldenbooks')
order by stor_id, s.qty DESC
go

/*
stor_id stor_name                                ord_date                qty
------- ---------------------------------------- ----------------------- ------
B251    B Dalton Bookseller                      1995-01-23 00:00:00.000 1740
B251    B Dalton Bookseller                      1994-11-04 00:00:00.000 1704
B251    B Dalton Bookseller                      1995-02-22 00:00:00.000 1560
B510    Barnes & Noble                           1995-08-13 00:00:00.000 1464
B510    Barnes & Noble                           1994-10-08 00:00:00.000 1200
B510    Barnes & Noble                           1993-01-08 00:00:00.000 924
P963    Waldenbooks                              1995-07-07 00:00:00.000 1668
P963    Waldenbooks                              1993-12-30 00:00:00.000 1068
P963    Waldenbooks                              1993-03-29 00:00:00.000 1032
Q017    Waldenbooks                              1994-11-02 00:00:00.000 1776
Q017    Waldenbooks                              1993-06-15 00:00:00.000 1704
Q017    Waldenbooks                              1994-02-24 00:00:00.000 1548
*/

--The following example replaces CROSS APPLY with the OUTER APPLY clause
select st.stor_id, stor_name, s.ord_date, s.qty
from stores st
outer apply
dbo.fn_GetTopOrders (st.stor_id, 3) as s
where st.state = 'MI'
and st.stor_name in ('Barnes & Noble', 'B Dalton BookSeller', 'Waldenbooks')
order by stor_id, s.qty DESC
go

/*
stor_id stor_name                                ord_date                qty
------- ---------------------------------------- ----------------------- ------
B251    B Dalton Bookseller                      1995-01-23 00:00:00.000 1740
B251    B Dalton Bookseller                      1994-11-04 00:00:00.000 1704
B251    B Dalton Bookseller                      1995-02-22 00:00:00.000 1560
B510    Barnes & Noble                           1995-08-13 00:00:00.000 1464
B510    Barnes & Noble                           1994-10-08 00:00:00.000 1200
B510    Barnes & Noble                           1993-01-08 00:00:00.000 924
B511    Barnes & Noble                           NULL                    NULL
P963    Waldenbooks                              1995-07-07 00:00:00.000 1668
P963    Waldenbooks                              1993-12-30 00:00:00.000 1068
P963    Waldenbooks                              1993-03-29 00:00:00.000 1032
Q017    Waldenbooks                              1994-11-02 00:00:00.000 1776
Q017    Waldenbooks                              1993-06-15 00:00:00.000 1704
Q017    Waldenbooks                              1994-02-24 00:00:00.000 1548
*/
