--Listing 35.30 - An Example of a Standard Error Handler Procedure
use bigpubs2005
go
create proc dbo.error_handler
as
begin
    Declare @errnum int,
            @severity int,
            @errstate int,
            @proc nvarchar(126),
            @line int,
            @message nvarchar(4000)
    -- capture the error information that caused the CATCH block to be invoked
    SELECT @errnum = ERROR_NUMBER(),
           @severity = ERROR_SEVERITY(),
           @errstate = ERROR_STATE(),
           @proc = ERROR_PROCEDURE(),
           @line = ERROR_LINE(),
           @message = ERROR_MESSAGE()
    -- raise an error message with information on the error
    RAISERROR ('Failed to add new publisher for the following reason:
 Error: %d, Severity: %d, State: %d, in proc %s at line %d, Message: "%s"',
               16, 1, @errnum, @severity, @errstate, @proc, @line, @message)
    Return
end
