--Listing 35.4 - Using OUTPUT to Capture a Computed Column
create table UpdateOutputTest
(col1 tinyint,
 col2 tinyint,
 computed_col3 as convert(float, col2/convert(float, col1)))
go

insert UpdateOutputTest (col1, col2)
  output inserted.computed_col3
  values (10, 20)
insert UpdateOutputTest (col1, col2)
  output inserted.computed_col3
  values (10, 25)
go

/*
computed_col3
----------------------
2
computed_col3
----------------------
2.5
*/

declare @output_table TABLE (del_col1 int, ins_col1 int,
                       del_col2 int, ins_col2 int,
                       del_computed_col3 float, ins_computed_col3 float,
                       mod_date datetime)
update UpdateOutputTest
   set col2 = col2/5.0
   output deleted.col1, inserted.col1,
          deleted.col2, inserted.col2,
          deleted.computed_col3, inserted.computed_col3,
          getdate()
      into @output_table
   output deleted.computed_col3,
          inserted.computed_col3,
          getdate() as mod_date
select del_col1, ins_col1, del_col2, ins_col2,
       del_computed_col3 as del_col3,  ins_computed_col3 as ins_col3,
       mod_date from @output_table
go

/*
computed_col3          computed_col3          mod_date
---------------------- ---------------------- -----------------------
2                      0.4                    2006-11-19 20:13:42.077
2.5                    0.5                    2006-11-19 20:13:42.077

del_col1 ins_col1 del_col2 ins_col2 del_col3 ins_col3 mod_date
-------- -------- -------- -------- -------- -------- -----------------------
10       10       20       4        2        0.4      2006-11-19 20:13:42.077
10       10       25       5        2.5      0.5      2006-11-19 20:13:42.077
*/
