--Listing 35.9 - A Recursive CTE to Return a Part and All Subparts
WITH PartsCTE(partid, partname, parentpartid, lvl)
AS
(
  SELECT partid, partname, parentpartid, 0
  FROM PARTS
  WHERE partid = 2 -- Engine
  UNION ALL

  SELECT P.partid, P.partname, P.parentpartid, PP.lvl+1
  FROM Parts as P
    JOIN PartsCTE as PP
      ON P.parentpartid = PP.Partid
)
SELECT PartID, Partname, ParentPartid, lvl
FROM PartsCTE
go

/*
PartID      Partname                       ParentPartid lvl
----------- ------------------------------ ------------ -----------
2           Engine                         1            0
5           Radiator                       2            1
6           Intake Manifold                2            1
7           Exhaust Manifold               2            1
8           Carburetor                     2            1
13          Piston                         2            1
14          Crankshaft                     2            1
21          Piston Rings                   13           2
11          Float Valve                    8            2
*/
