using System;
using System.Data;
using Microsoft.SqlServer.Server;

//added:  
using System.Data.SqlClient;
using SQLCLR.photoserve;

public partial class Triggers
{
  [Microsoft.SqlServer.Server.SqlTrigger(
    Event = "FOR UPDATE",
    Name = "Production.PhotoUpdateTrigger",
    Target = "Production.ProductPhoto"
  )]
  public static void PhotoUpdateTrigger()
  {
    SqlTriggerContext stc = SqlContext.TriggerContext;
    if (stc.TriggerAction == TriggerAction.Update)
    {
      if (stc.IsUpdatedColumn(3)) //The LargePhoto varbinary(max) column
      {   
        using (SqlCommand s = new SqlCommand(
          "SELECT DISTINCT ProductPhotoId FROM INSERTED",
          new SqlConnection("context connection=true")))
        {
          s.Connection.Open();
          using (SqlDataReader r = 
            s.ExecuteReader(CommandBehavior.CloseConnection))
          {
            PhotoService p = new PhotoService();
            while (r.Read())
            {
                SqlContext.Pipe.Send(
                  "Notifying Web Service of Update for PPID: " + 
                  r.GetInt32(0).ToString());
                  p.PhotoUpdateNotify(r.GetInt32(0));
            }
          }
        }
      }
    }
  }    
}
