using System;
using System.Data;
using System.Data.Sql;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Data.SqlClient; // added
using System.IO; // added
using System.Security.Permissions; // added

namespace Routines
{
  public partial class StoredProcedures
  {
    [Microsoft.SqlServer.Server.SqlProcedure(
       Name = "sp_GetSetIllustrationWebLinks"
    )]
    public static void GetSetIllustrationWebLinks(int ProductModelId)
    {
      using (SqlConnection c = new SqlConnection("Data Source=(local);Initial Catalog=AdventureWorks;Integrated Security=True"))
      {
        using (SqlCommand scADO = new SqlCommand())
        {
          c.Open();
          scADO.Connection = c;
          scADO.CommandText = "Production.GetIllustrationsByProductModel";
          SqlParameter pmId = new SqlParameter("ProductModelId", ProductModelId);
          scADO.Parameters.Add(pmId);
          scADO.CommandType = CommandType.StoredProcedure;
          SqlDataReader reader = scADO.ExecuteReader();

          using (SqlConnection ContextConnection = 
            new SqlConnection("context connection=true"))
          {
            SqlDataRecord record =
                  new SqlDataRecord(
                      new SqlMetaData[] 
                  {
                    new SqlMetaData("IllustrationId", 
                      SqlDbType.Int),
                    new SqlMetaData("SVGURL", 
                      SqlDbType.VarChar, 1000)
                  }
                );

            SqlContext.Pipe.SendResultsStart(record);

            while (reader.Read())
            {
              SqlXml x = reader.GetSqlXml(2);
              if (!x.IsNull)
              {
                Int32 IllId = reader.GetInt32(0);

                string FileName = IllId.ToString() + 
                    "__" + reader.GetString(1) + ".svg";
                
                string SVGURL = "http://localhost/Illustrations/" +
                  FileName;

                string FilePath = @"e:\inetpub\wwwroot\illustrations\";

                FileIOPermission fp = new FileIOPermission(
                    FileIOPermissionAccess.Write,
                    FilePath);

                fp.Demand();

                using (StreamWriter sw = new StreamWriter(
                    FilePath + FileName))
                {
                  sw.Write(x.Value);
                }

                using (SqlCommand scCLR = new SqlCommand())
                {
                  scCLR.Connection = c;
                  scCLR.CommandType = CommandType.StoredProcedure;
                  scCLR.CommandText =
                    "Production.InsertUpdateIllustrationWebLink";
                  
                  scCLR.Parameters.Add("@IllustrationId", 
                    SqlDbType.Int).Value = IllId;
                  
                  scCLR.Parameters.Add("@IllustrationURL", 
                    SqlDbType.VarChar, 1000).Value = SVGURL;

                  scCLR.ExecuteNonQuery();
                  record.SetInt32(0, IllId);
                  record.SetString(1, SVGURL);
                  SqlContext.Pipe.SendResultsRow(record);
                }
              }  
            }
            SqlContext.Pipe.SendResultsEnd();
          }
        }
      }
    }
  }
}
