INSERT HumanResources.XmlResources
SELECT 
    1,
    'ResumeAddressTransformer',
    '<?xml version="1.0" ?>
<xsl:stylesheet 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:ns="http://schemas.microsoft.com/sqlserver/2004/07/adventure-
[ic:ccc]works/Resume"
    version="1.0">
    <xsl:template match="ns:Resume">
        <NameAndAddress>
            <xsl:apply-templates/>
        </NameAndAddress>
    </xsl:template>

    <xsl:template match="ns:Name">
        <Name>
            <xsl:value-of select="ns:Name.First"/>
            <xsl:text disable-output-escaping="yes">&#160;</xsl:text>
            <xsl:value-of select="ns:Name.Last"/>
        </Name>
    </xsl:template>

    <xsl:template match="ns:Address[ns:Addr.Type=''Home'']">
        <HomeAddress>
            <HomeStreet>
                <xsl:value-of select="ns:Addr.Street"/>
            </HomeStreet>
            <HomeCity>
                <xsl:value-of 
[ic:ccc]select="ns:Addr.Location/ns:Location/ns:Loc.City"/>
            </HomeCity>
            <HomeState>
                <xsl:value-of 
[ic:ccc]select="ns:Addr.Location/ns:Location/ns:Loc.State"/>
            </HomeState>
            <HomeZip>
                <xsl:value-of select="ns:Addr.PostalCode"/>
            </HomeZip>
        </HomeAddress>
    </xsl:template>
    <xsl:template match="node()"/>
</xsl:stylesheet>
'