--Listing 46.12 - Using the GROUPING Function
SELECT CASE when GROUPING(type) = 1 then 'ALL'
            else isnull(type, 'Other')
            END AS type,
       cast(CASE when (grouping(advance) = 1) then 'ALL'
            else isnull(convert(varchar(10), advance), 'Unknown')
            END  as varchar(10)) as advance,
       count(*) AS number
   FROM DBO.titles
   where type like '%cook%' or type like 'p%'
   GROUP BY type, advance
   WITH rollup
go

/*
type         advance    number
------------ ---------- -----------
mod_cook     0.00       1
mod_cook     15000.00   1
mod_cook     ALL        2
popular_comp Unknown    1
popular_comp 7000.00    1
popular_comp 8000.00    1
popular_comp ALL        3
psychology   2000.00    1
psychology   2275.00    1
psychology   4000.00    1
psychology   6000.00    1
psychology   7000.00    1
psychology   ALL        5
trad_cook    4000.00    1
trad_cook    7000.00    1
trad_cook    8000.00    1
trad_cook    ALL        3
ALL          ALL        13
*/
