-- Listing 46.2 - Stripping Out the UNION Clause to Help Avoid SQL Injection
alter proc get_titles @type varchar(12) = null,
                      @pubdate varchar(10) = null,
                      @price varchar(6) = null,
                      @title varchar(80) = null
as
declare @where varchar(4000),
        @query varchar(8000)
set @query = 'select left(title, 60) as title,
       convert (char(10), pubdate, 101) as pubdate from dbo.titles '
set @where = ' WHERE 1 = 1 '
if @type is not null
    set @where = @where + ' AND type = ''' + @type + ''''
if @pubdate is not null
    set @where = @where + ' AND pubdate = ''' + @pubdate + ''''
if @price is not null
    set @where = @where + ' AND price = ' + @price
if @title is not null
    set @where = @where + ' AND title like ''' + @title + ''''

-- The following statement truncate the @where clause at the point where
--  it finds the UNION statement
select @query = @query + left(@where, charindex('UNION', @where) - 1)
exec (@query)

return
go

exec dbo.get_titles @title = ''' UNION ALL select name, null from syscolumns where id = 1253579504--'
go

/*
title                                                        pubdate
------------------------------------------------------------ ----------

*/
