--Listing 46.28 - Using a Common Table Expression to Identify Duplicate Rows
WITH authors_import AS
(SELECT ROW_NUMBER() OVER (ORDER BY au_id, au_lname, au_fname) AS ROWID, *
   FROM dbo.authors_import)
select * FROM authors_import WHERE ROWID NOT IN
(SELECT MIN(ROWID) FROM authors_import
   GROUP BY au_id,au_fname, au_lname);
GO

/*
ROWID                au_id       au_lname                       au_fname
-------------------- ----------- ------------------------------ -----------------
5                    432-31-3829 Bate                           W. Jackson
6                    432-31-3829 Bate                           W. Jackson
9                    499-84-5672 Alexander                      Lloyd
*/

WITH authors_import AS
(SELECT ROW_NUMBER() OVER (ORDER BY au_id, au_lname, au_fname) AS ROWID, *
   FROM dbo.authors_import)
delete FROM authors_import WHERE ROWID NOT IN
(SELECT MIN(ROWID) FROM authors_import
   GROUP BY au_id,au_fname, au_lname);
GO
select * from authors_import
go

/*
au_id       au_lname                       au_fname
----------- ------------------------------ --------------------
681-61-9588 Ahlberg                        Allan
739-35-5165 Ahlberg                        Janet
499-84-5672 Alexander                      Lloyd
432-31-3829 Bate                           W. Jackson
437-99-3329 Bauer                          Caroline Feller
378-33-9373 Benchley                       Nathaniel
378-33-9373 Benchley                       Nate
409-56-7008 Bennet                         Abraham
*/
