--Listing 46.3 - Using sp_executsql to Help Avoid SQL Injection
alter proc get_titles @type varchar(12) = null,
                      @pubdate varchar(10) = null,
                      @price varchar(6) = null,
                      @title varchar(80) = null
as
declare @where nvarchar(2000),
        @query nvarchar(2000)
set @query = 'select left(title, 60) as title,
       convert (char(10), pubdate, 101) as pubdate from dbo.titles '
set @where = ' WHERE 1 = 1 '
if @type is not null
    set @where = @where + ' AND type = @type '
if @pubdate is not null
    set @where = @where + ' AND pubdate = @pubdate '
if @price is not null
    set @where = @where + ' AND price = convert(money, @price) '
if @title is not null
    set @where = @where + ' AND title like @title '
-- Build the final query
select @query = @query + @where
exec sp_executesql @query,
   N'@type varchar(12), @pubdate varchar(10),
     @price varchar(6), @title varchar(80)',
   @type, @pubdate, @price, @title

return
go

