USE PLDebitTracking
GO
-- Do Events Exist?
SELECT *
FROM PLApplication.PLDebitEvent
GO
-- Do Subscriptions Exist?
SELECT *
FROM PLApplication.PLDebitSubscription
GO
-- Do Event-Subscription Matches Exist? (tests the rule's Action)
SELECT DISTINCT
  sub.SubscriberId,
  'DefaultDevice' DeviceName,
  'EN-US' SubscriberLocale,
  event.AccountNumber,
  event.InstitutionName,
  event.AmountDebited,
  GETDATE() DatePosted
FROM PLApplication.PLDebitEvent event
JOIN PLApplication.PLDebitSubscription sub
ON event.AccountNumber = sub.AccountNumber
AND event.InstitutionName = sub.InstitutionName
AND event.AmountDebited >= sub.ThresholdAmount
GO
-- Did any Notifications Fail? (Check if created HTML file is empty)
EXEC PLInstance.NSDiagnosticFailedNotifications
