<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="notifications">
    <html>
      <head>
        <title>PLDebit Notification System: Alert</title>
      </head>
      <body>
        <h1>Paperless Debit Transactions</h1>
        <h2>
          PLDebit&apos;s automated tracking system caught the following events:
        </h2>
        <h3>
          One or more paperless debits occurred in your account.
        </h3>
        <h4>
          Debit information follows:
        </h4>
          <table border="1">
            <tr>
              <th>Institution</th>
              <th>Amount</th>
              <th>Date Posted</th>
            </tr>
            <xsl:for-each select="notification">
              <tr>
                <td>
                  <i>
                    <xsl:value-of select="InstitutionName" />
                  </i>
                </td>
                <td>
                  $<xsl:value-of select="AmountDebited" />
                </td>
                <td>
                  <xsl:value-of select="DatePosted" />
                </td>
              </tr>
            </xsl:for-each>
          </table>
          <h5>
          Sincerely,<br/>
          PLDebit
        </h5>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
