CREATE DATABASE XCatMgmt WITH TRUSTWORTHY ON
GO
ALTER DATABASE XCatMgmt SET ENABLE_BROKER
GO
USE XCatMgmt
GO
DROP MASTER KEY
GO
CREATE MASTER KEY 
ENCRYPTION BY PASSWORD = 'XCatMgmt';
GO
CREATE SCHEMA Publication
CREATE TABLE Publication.BaseCatalog
(
	CatalogId int IDENTITY(1,1) PRIMARY KEY,
	CatalogName varchar(100) NOT NULL,
	LastPublicationDate datetime
)
CREATE TABLE Publication.Product
(
	ProductId int IDENTITY(1,1) PRIMARY KEY,
	ProductName varchar(100) NOT NULL,
	SourceProductId int NOT NULL,
	ManufacturerId int NOT NULL,
	Price money NOT NULL,
	ProductDetailXml xml, 
	CreateDate datetime NOT NULL,
	LastUpdateDate datetime DEFAULT GETDATE()
)
CREATE TABLE Publication.ProductCatalogType
(
	ProductCatalogTypeId int PRIMARY KEY,
	Description varchar(100)
)
CREATE TABLE Publication.ProductCatalog
(
	ProductCatalogId int IDENTITY(1,1) PRIMARY KEY,
	ProductCatalogTypeId int NOT NULL 
		REFERENCES Publication.ProductCatalogType(ProductCatalogTypeId),
	ProductId int NOT NULL
		REFERENCES Publication.Product(ProductId),
	CatalogId int NOT NULL
		REFERENCES Publication.BaseCatalog(CatalogId)
)
GO
INSERT Publication.ProductCatalogType
SELECT 1, 'Mountain Bicycles and Parts'
INSERT Publication.BaseCatalog (CatalogName)
SELECT 'The Complete Catalog of Wholesale Mountain Bike Parts'
INSERT Publication.Product
(
	ProductName,
	SourceProductId,
	ManufacturerId,
	Price,
	ProductDetailXml,
	CreateDate
)
SELECT 'AdventureWorksProductName', 749, 1, 99.99, '<empty/>', GETDATE()
INSERT Publication.ProductCatalog
SELECT 1, 1, 1
