USE XBikeDistribution
GO
CREATE MESSAGE TYPE 
[//samspublishing.com/SS2005/SSB/MessageTypes/CatalogChangeNotifySimple]
AUTHORIZATION [SSBTestUserName] VALIDATION = WELL_FORMED_XML;
GO
CREATE MESSAGE TYPE 
[//samspublishing.com/SS2005/SSB/MessageTypes/GenericAck]
AUTHORIZATION [SSBTestUserName] VALIDATION = VALID_XML
WITH SCHEMA COLLECTION GenericAcknowledgementSchema
GO
CREATE CONTRACT
[//samspublishing.com/SS2005/SSB/Contracts/SimpleCatalogNotifyContract]
AUTHORIZATION [SSBTestUserName]
(
	[//samspublishing.com/SS2005/SSB/MessageTypes/CatalogChangeNotifySimple]
		SENT BY INITIATOR,
	[//samspublishing.com/SS2005/SSB/MessageTypes/GenericAck]
		SENT BY TARGET	
)
GO
CREATE PROC Cataloging.CatalogChangeNotifyQueueReader
AS
GO
CREATE QUEUE Cataloging.CatalogChangeNotifyReceiveQueue
WITH
STATUS = ON,
ACTIVATION 
(
	STATUS = ON,
	PROCEDURE_NAME = Cataloging.CatalogChangeNotifyQueueReader,
	MAX_QUEUE_READERS = 10,
	EXECUTE AS 'SSBTestUserName'
)
GO
CREATE SERVICE
[//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyTarget]
ON QUEUE Cataloging.CatalogChangeNotifyReceiveQueue
( [//samspublishing.com/SS2005/SSB/Contracts/SimpleCatalogNotifyContract] )
GO
CREATE ROUTE 
[//samspublishing.com/SS2005/SSB/Routes/RouteToCatalogChangeNotifyInitator]
WITH 
SERVICE_NAME = 
'//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyInitiator',
ADDRESS = 'TCP://192.168.22.5:4022';
GO
CREATE REMOTE SERVICE BINDING 
[//samspublishing.com/SS2005/SSB/RSBindings/RSBForCatalogChangeNotifyInitator]
TO SERVICE
'//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyInitiator'
WITH USER = [SSBTestUserName],
ANONYMOUS = OFF
GO
GRANT SEND ON 
SERVICE::[//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyTarget]
TO [SSBTestUserName]
