USE XCatMgmt
GO
CREATE MESSAGE TYPE 
[//samspublishing.com/SS2005/SSB/MessageTypes/CatalogChangeNotifySimple]
AUTHORIZATION [SSBTestUserName] VALIDATION = WELL_FORMED_XML;
GO
CREATE CONTRACT
[//samspublishing.com/SS2005/SSB/Contracts/SimpleCatalogNotifyContract]
AUTHORIZATION [SSBTestUserName]
(
	[//samspublishing.com/SS2005/SSB/MessageTypes/CatalogChangeNotifySimple]
		SENT BY INITIATOR,
	[//samspublishing.com/SS2005/SSB/MessageTypes/GenericAck]
		SENT BY TARGET
)
GO
CREATE PROC Publication.CatalogChangeNotifyAckQueueReader
AS
GO
CREATE QUEUE Publication.CatalogChangeNotifyAckQueue
WITH
STATUS = ON,
ACTIVATION 
(
	STATUS = ON,
	PROCEDURE_NAME = Publication.CatalogChangeNotifyAckQueueReader,
	MAX_QUEUE_READERS = 10,
	EXECUTE AS 'SSBTestUserName'
)
GO
CREATE SERVICE
[//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyInitiator]
ON QUEUE Publication.CatalogChangeNotifyAckQueue
( [//samspublishing.com/SS2005/SSB/Contracts/SimpleCatalogNotifyContract] )
GO
CREATE ROUTE 
[//samspublishing.com/SS2005/SSB/Routes/RouteToCatalogChangeNotifyTarget]
WITH 
SERVICE_NAME = 
'//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyTarget',
ADDRESS = 'TCP://192.168.22.6:4022';
GO
CREATE REMOTE SERVICE BINDING 
[//samspublishing.com/SS2005/SSB/RSBindings/RSBForCatalogChangeNotifyTarget]
TO SERVICE
'//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyTarget'
WITH USER = [SSBTestUserName],
ANONYMOUS = OFF
GO
GRANT SEND ON 
SERVICE::[//samspublishing.com/SS2005/SSB/Services/CatalogChangeNotifyInitiator]
TO [SSBTestUserName]
